#include "time_util.h"
#include <sys/time.h>


double CurrentMicroSecond()
{
	timeval now;
	gettimeofday(&now, 0);
	return now.tv_sec + now.tv_usec / 1000000.0;
}


double WaitNextEvent(double last_time, double interval)
{
	const double remaining (last_time + interval - CurrentMicroSecond());
	if (remaining > 0) {
		timeval timeout;
		 // ignore fractional part of number > 0
		timeout.tv_sec = static_cast<unsigned long>(remaining);
		// keep only fractional part
		timeout.tv_usec = static_cast<suseconds_t>((remaining - timeout.tv_sec) * 1000000);
		select(0, 0, 0, 0, &timeout);
	}
	return CurrentMicroSecond();
}
